#include "GesamtSpielerStatistik.h"

// Inhalt der GesamtSpielerStatistik Klasse aus GesamtSpielerStatistik.h
// Konstruktor
GesamtSpielerStatistik::GesamtSpielerStatistik()
{
	spielerNummer = 0;
	spielerName = new Text();
	teamName = new Text();
	spielerFarbe = 0;
	teamFarbe = 0;
	gewonneneRunden = 0;
	punkte = 0;
	linienLength = 0;
	zeitAmLeben = 0;
	zeitTod = 0;
	kills = 0;
	tode = 0;
	ref = 1;
}

// Destruktor
GesamtSpielerStatistik::~GesamtSpielerStatistik()
{
	spielerName->release();
	teamName->release();
}

// nicht constant
void GesamtSpielerStatistik::initValues( InitDatei *dat )
{
	if( dat->wertExistiert( "SpielerNummer" ) )
		spielerNummer = *dat->zWert( "SpielerNummer" );
	if( dat->wertExistiert( "SpielerName" ) )
		*spielerName = dat->zWert( "SpielerName" )->getText();
	if( dat->wertExistiert( "TeamName" ) )
		*teamName = dat->zWert( "TeamName" )->getText();
	if( dat->wertExistiert( "SpielerFarbe" ) )
		spielerFarbe = *dat->zWert( "SpielerFarbe" );
	if( dat->wertExistiert( "TeamFarbe" ) )
		teamFarbe = *dat->zWert( "TeamFarbe" );
	if( dat->wertExistiert( "GewonneneRunden" ) )
		gewonneneRunden = *dat->zWert( "GewonneneRunden" );
	if( dat->wertExistiert( "Punkte" ) )
		punkte = *dat->zWert( "Punkte" );
	if( dat->wertExistiert( "LinienLänge" ) )
		linienLength = *dat->zWert( "LinienLänge" );
	if( dat->wertExistiert( "ZeitAmLeben" ) )
		zeitAmLeben = *dat->zWert( "ZeitAmLeben" );
	if( dat->wertExistiert( "ZeitTod" ) )
		zeitTod = *dat->zWert( "ZeitTod" );
	if( dat->wertExistiert( "Kills" ) )
		kills = *dat->zWert( "Kills" );
	if( dat->wertExistiert( "Tode" ) )
		tode = *dat->zWert( "Tode" );
	dat->release();
}

// constant
int GesamtSpielerStatistik::getSpielerNummer() const
{
	return spielerNummer;
}

Text *GesamtSpielerStatistik::getSpielerName() const
{
	return spielerName ? spielerName->getThis() : 0;
}

Text *GesamtSpielerStatistik::zSpielerName() const
{
	return spielerName;
}

Text *GesamtSpielerStatistik::getTeamName() const
{
	return teamName ? teamName->getThis() : 0;
}

Text *GesamtSpielerStatistik::zTeamName() const
{
	return teamName;
}

int GesamtSpielerStatistik::getSpielerFarbe() const
{
	return spielerFarbe;
}

int GesamtSpielerStatistik::getTeamFarbe() const
{
	return teamFarbe;
}

int GesamtSpielerStatistik::getGewonneneRunden() const
{
	return gewonneneRunden;
}

int GesamtSpielerStatistik::getPunkte() const
{
	return punkte;
}

int GesamtSpielerStatistik::getLinienLength() const
{
	return linienLength;
}

int GesamtSpielerStatistik::getZeitAmLeben() const
{
	return zeitAmLeben;
}

int GesamtSpielerStatistik::getZeitTod() const
{
	return zeitTod;
}

int GesamtSpielerStatistik::getKills() const
{
	return kills;
}

int GesamtSpielerStatistik::getTode() const
{
	return tode;
}

// Reference Counting
GesamtSpielerStatistik *GesamtSpielerStatistik::getThis()
{
	ref++;
	return this;
}

GesamtSpielerStatistik *GesamtSpielerStatistik::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}